// Code generated by go-swagger; DO NOT EDIT.

package app_setup

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "gitlab.com/pear-slices/mobile_platform/bitrise-step-api-build-trigger/models"
)

// AppFinishReader is a Reader for the AppFinish structure.
type AppFinishReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AppFinishReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewAppFinishOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewAppFinishBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewAppFinishUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewAppFinishNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewAppFinishInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewAppFinishOK creates a AppFinishOK with default headers values
func NewAppFinishOK() *AppFinishOK {
	return &AppFinishOK{}
}

/*AppFinishOK handles this case with default header values.

OK
*/
type AppFinishOK struct {
	Payload *models.V0AppFinishRespModel
}

func (o *AppFinishOK) Error() string {
	return fmt.Sprintf("[POST /apps/{app-slug}/finish][%d] appFinishOK  %+v", 200, o.Payload)
}

func (o *AppFinishOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.V0AppFinishRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAppFinishBadRequest creates a AppFinishBadRequest with default headers values
func NewAppFinishBadRequest() *AppFinishBadRequest {
	return &AppFinishBadRequest{}
}

/*AppFinishBadRequest handles this case with default header values.

Bad Request
*/
type AppFinishBadRequest struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *AppFinishBadRequest) Error() string {
	return fmt.Sprintf("[POST /apps/{app-slug}/finish][%d] appFinishBadRequest  %+v", 400, o.Payload)
}

func (o *AppFinishBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAppFinishUnauthorized creates a AppFinishUnauthorized with default headers values
func NewAppFinishUnauthorized() *AppFinishUnauthorized {
	return &AppFinishUnauthorized{}
}

/*AppFinishUnauthorized handles this case with default header values.

Unauthorized
*/
type AppFinishUnauthorized struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *AppFinishUnauthorized) Error() string {
	return fmt.Sprintf("[POST /apps/{app-slug}/finish][%d] appFinishUnauthorized  %+v", 401, o.Payload)
}

func (o *AppFinishUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAppFinishNotFound creates a AppFinishNotFound with default headers values
func NewAppFinishNotFound() *AppFinishNotFound {
	return &AppFinishNotFound{}
}

/*AppFinishNotFound handles this case with default header values.

Not Found
*/
type AppFinishNotFound struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *AppFinishNotFound) Error() string {
	return fmt.Sprintf("[POST /apps/{app-slug}/finish][%d] appFinishNotFound  %+v", 404, o.Payload)
}

func (o *AppFinishNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAppFinishInternalServerError creates a AppFinishInternalServerError with default headers values
func NewAppFinishInternalServerError() *AppFinishInternalServerError {
	return &AppFinishInternalServerError{}
}

/*AppFinishInternalServerError handles this case with default header values.

Internal Server Error
*/
type AppFinishInternalServerError struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *AppFinishInternalServerError) Error() string {
	return fmt.Sprintf("[POST /apps/{app-slug}/finish][%d] appFinishInternalServerError  %+v", 500, o.Payload)
}

func (o *AppFinishInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
